# coding: utf-8
"""Waylay Resources models.

This code was generated from the OpenAPI documentation of 'Waylay Resources'

Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.

"""

from __future__ import annotations

import re
from typing import Any, Dict

from pydantic import (
    ConfigDict,
    Field,
    StrictStr,
    field_validator,
)
from typing_extensions import (
    Annotated,  # >=3.11
)
from waylay.sdk.api._models import BaseModel as WaylayBaseModel


class ResourceSensorSensor(WaylayBaseModel):
    """ResourceSensorSensor."""

    name: StrictStr = Field(description="The identifying name of the _Waylay Sensor_")
    version: Annotated[str, Field(strict=True)] | None = Field(
        default=None, description="The sensor version"
    )
    properties: Dict[str, Any] | None = Field(
        default=None, description="Default sensor property configuration."
    )

    @field_validator("version")
    @classmethod
    def version_validate_regular_expression(cls, value):
        """Validate the regular expression."""
        if value is None:
            return value
        if not re.match(r"\d+\.\d+\.\d+", value):
            raise ValueError(r"must validate the regular expression /\d+\.\d+\.\d+/")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
        extra="ignore",
    )
